#include<iostream>
#include<algorithm>
using namespace std;
struct dani_kupioS {
    unsigned long long int dani;
    unsigned long long int kupio;
};
bool sortDani(dani_kupioS,dani_kupioS);
unsigned long long int prebroj(unsigned long long int[],unsigned long long int);
int main(){
    unsigned int N,Q;
    cin>>N>>Q;
    dani_kupioS dani_kupio[N+1]={0};
    unsigned long long int pitanja[Q]={0};
    unsigned long long int odgovori[Q]={0};
    unsigned long long int zbir=0;
    for(unsigned long long int i=1;i<=N;i++){
        cin>>dani_kupio[i].dani>>dani_kupio[i].kupio;
        zbir+=dani_kupio[i].kupio;
    }
    for(unsigned long long int i=0;i<Q;i++){
        cin>>pitanja[i];
    }
    sort(dani_kupio,dani_kupio+(N+1),sortDani);
    sort(pitanja,pitanja+Q);
    unsigned long long int posPit = pitanja[Q-1];
    unsigned long long int posDan = dani_kupio[N].dani;
    unsigned long long int stanje[posDan+1]={0};
    unsigned long long int nema[posDan+1]={0};
    for(unsigned long long int i=1;i<=N;i++){
        stanje[dani_kupio[i].dani] = dani_kupio[i].kupio;
    }

    for(unsigned long long int i=1;i<=posDan;i++){
        if(stanje[i-1]>0){
            stanje[i] += stanje[i-1]-1;
        }
    }
    for(unsigned long long int i=1;i<=posDan;i++){
        if(stanje[i] == 0)
            nema[i]++;
    }
    unsigned long long int a;
    for(unsigned long long int i=0;i<Q;i++){
        if(pitanja[i]>posDan){
            if(pitanja[i]<=zbir)
                odgovori[i]=pitanja[i]-prebroj(nema,posDan);
            else
                odgovori[i]=zbir;
        }
        else
            odgovori[i] = pitanja[i]-prebroj(nema,pitanja[i]);
    }

     for(unsigned long long int i=0;i<Q;i++){
        cout<<odgovori[i]<<endl;
    }
    return 0;
}
unsigned long long int prebroj(unsigned long long int niz[],unsigned long long int N){
    unsigned long long int a=0;
    for(unsigned long long int i=1;i<=N;i++)
        if(niz[i] == 1)
            ++a;
    return a;
}
bool sortDani(dani_kupioS a, dani_kupioS b){
    return a.dani<b.dani;
}